#!/usr/bin/perl -w
use strict;

print "Content-type:text/html\n\n";

#check perl version, 5.6.1 or better
my $perl_version    = "Perl " . ( sprintf "%vd", $^V );
my %year = (
    '5.4' => '1997',
    '5.4.0' => '1997',
    '5.4.1' => '1997',
    '5.4.2' => '1997',
    '5.4.3' => '1997',
    '5.4.4' => '1997',
    '5.4.50' => '1997',
    '5.4.51' => '1997',
    '5.4.52' => '1997',
    '5.4.53' => '1997',
    '5.4.54' => '1997',
    '5.4.55' => '1997',
    '5.4.56' => '1997',
    '5.4.57' => '1998',
    '5.4.58' => '1998',
    '5.4.59' => '1998',
    '5.4.60' => '1998',
    '5.4.61' => '1998',
    '5.4.62' => '1998',
    '5.4.63' => '1998',
    '5.4.64' => '1998',
    '5.4.65' => '1998',
    '5.4.66' => '1998',
    '5.4.67' => '1998',
    '5.4.68' => '1998',
    '5.4.69' => '1998',
    '5.4.70' => '1998',
    '5.4.71' => '1998',
    '5.4.72' => '1998',
    '5.4.73' => '1998',
    '5.4.74' => '1998',
    '5.4.75' => '1998',
    '5.4.76' => '1998',

    '5.5' => '1998',
    '5.5.0' => '1998',
    '5.5.1' => '1998',
    '5.5.2' => '1998',
    '5.5.3' => '1999',
    '5.5.4' => '2004 but is a maintenance update for a version dating '
      . 'back to 1999',

    '5.6' => '2000',
    '5.6.0' => '2000',
);
my $year = $year{$perl_version} || 'the last millennium';
eval { require 5.006_001 };
if ($@) {
    print 'Big Medium requires Perl 5.6.1 or higher, but your server is ',
      "running $perl_version. Ask your hosting company or server admin ",
      "if it's possible to upgrade (your current version was released in $year).";
    exit;
}
print "$perl_version: OK<br><br>";

#check image
my $img = get_image_lib();
if (!$img) {
    print "No image library installed.<br>";
    print 'An image library is not required but is highly recommended. ',
      'This allows Big Medium to manage and resize images for you. Ask your ',
      q{hosting company or server admin if it's possible to install },
      q{ImageMagick and PerlMagick (a.k.a. the Image::Magick Perl module) },
      q{on your server. For more info:<br>},
      q{<a href="http://www.imagemagick.org/">},
      q{http://www.imagemagick.org/</a><br><br>};
}
elsif (index($img, 'GD') == 0) {
    print "Image library: $img<br>",
      q{The GD image library works with Big medium, but its image results },
      q{are often poor. This means that thumbnails and other resized },
      q{images could appear grainy. Ask your hosting company or server },
      q{admin if it's possible to install ImageMagick and PerlMagick },
      q{instead (a.k.a. the Image::Magick Perl module). },
      q{If that's not possible; it's okay. Your server will still },
      qq{run Big Medium just fine.<br><br>};
}
else {
    print "Image library ($img): OK<br><br>";
}

print q{You're all set! Your server has the necessary requirements to run },
 "Big Medium.<br>";

exit();

sub get_image_lib {
    eval { require Image::Magick; import Image::Magick; };
    if (!$@) {
        my $v = $Image::Magick::VERSION;
        return "ImageMagick v$v";
    }

    eval { require Imager; import Imager; };
    if (!$@) {
        my $v = $Imager::VERSION;
        return "Imager v$v";
    }

    return 'NetPBM' if find_netpbm();    
    
    eval { require GD; import GD; };
    if (!$@) {
        my $v = $GD::VERSION;
        return "GD v$v";
    }
    return;
}


sub find_netpbm {
    require Config;
    require File::Spec;
    require ExtUtils::MakeMaker;

    #see if we have the files, using pnmscale as the test
    my $command = 'pnmscale';

    #throw in /opt/local/bin too
    no warnings; #quiet the Config::Config
    my @dir = (
        split( /\Q$Config::Config{path_sep}\E/ms, $ENV{PATH} ),
        '/opt/local/bin',
    );
    my $netpbm_path;
    foreach my $dir (@dir) {
        my $abs = File::Spec->catfile( $dir, $command );
        $netpbm_path = $dir, last if MM->maybe_command($abs);
    }
    return (defined $netpbm_path);
}

__END__